package org.gcube.informationsystem.model.discovery;

import org.gcube.informationsystem.impl.utils.discovery.ISMDiscovery;
import org.gcube.informationsystem.model.embedded.Embedded;
import org.gcube.informationsystem.model.entity.Entity;
import org.gcube.informationsystem.model.relation.Relation;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ISMDiscoveryTest {

	private static Logger logger = LoggerFactory.getLogger(ISMDiscovery.class);
	
	@Test
	public void testEmbeddedDiscovery() throws Exception{
		ISMDiscovery<Embedded> embeddedDiscovery = new ISMDiscovery<>(Embedded.class);
		embeddedDiscovery.discover();
		
		for(Class<Embedded> embedded : embeddedDiscovery.getDiscovered()) {
			logger.info("Going to create : {}", embedded);
		}
	}
	
	@Test
	public void testEntityDiscovery() throws Exception{
		ISMDiscovery<Entity> entityDiscovery = new ISMDiscovery<>(Entity.class);
		entityDiscovery.discover();
		
		for(Class<Entity> entity : entityDiscovery.getDiscovered()) {
			logger.info("Going to create : {}", entity);
		}
	}
	
	@Test
	public void testRelationDiscovery() throws Exception{
		@SuppressWarnings("rawtypes")
		ISMDiscovery<Relation> relationDiscovery = new ISMDiscovery<>(Relation.class);
		relationDiscovery.discover();
	}
	
	
	
}
