package org.gcube.informationsystem.resourceregistry.context;

import java.io.File;
import java.io.IOException;
import java.util.UUID;

import org.gcube.informationsystem.impl.entity.ContextImpl;
import org.gcube.informationsystem.impl.utils.ISMapper;
import org.gcube.informationsystem.model.entity.Context;
import org.gcube.informationsystem.resourceregistry.api.exceptions.ResourceRegistryException;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ContextManagementTest {

	private static Logger logger = LoggerFactory.getLogger(ContextManagementTest.class);

	protected Context read(UUID uuid) throws ResourceRegistryException, IOException {
		ContextManagement contextManagement = new ContextManagement();
		contextManagement.setUUID(uuid);
		String contextString = contextManagement.read();
		logger.debug("Read {}", contextString);
		return ISMapper.unmarshal(Context.class, contextString);
	}
	
	protected Context create(Context context) throws ResourceRegistryException, IOException {
		ContextManagement contextManagement = new ContextManagement();
		contextManagement.setJSON(ISMapper.marshal(context));
		String contextString = contextManagement.create();
		logger.debug("Created {}", contextString);
		Context c = ISMapper.unmarshal(Context.class, contextString);
		return c;
	}

	// @Test
	public void createPreContext() throws Exception {
		Context gcube = new ContextImpl("gcube");
		gcube = create(gcube);
		
		Context preprod = new ContextImpl("preprod");
		preprod.setParent(gcube);
		preprod = create(preprod);

		Context parthenosVRE = new ContextImpl("PARTHENOS_PRE");
		parthenosVRE.setParent(preprod);
		parthenosVRE = create(parthenosVRE);
		
	}
	
	@Test
	public void createProductionContext() throws Exception {
		File src = new File("src");
		File test = new File(src, "test");
		File resources = new File(test, "resources");
		
		File voFile = new File(resources, "scopedata.xml");
		
		ContextCreator contextCreator = new ContextCreator();
		contextCreator.all(voFile);
	}
	
	
	
}
